Index: src/edu/ucsb/nceas/metacat/Eml200SAXHandler.java
===================================================================
--- src/edu/ucsb/nceas/metacat/Eml200SAXHandler.java	(revision 6743)
+++ src/edu/ucsb/nceas/metacat/Eml200SAXHandler.java	(revision 6744)
@@ -337,39 +337,39 @@
         // Get the unchangable subtrees (user doesn't have write permission)
         try
         {
-            PermissionController control = new PermissionController(docid
-                    + PropertyService.getProperty("document.accNumSeparator") + revision);
-            //unChangableSubTreeHash = getUnchangableSubTree(control, user,
-            // groups);
 
-            // If the action is update and user doesn't have "ALL" permission
-            // we need to check if user update access subtree
-            if (action != null && action.equals("UPDATE")
-                    && !control.hasPermission(user, groups,
-                            AccessControlInterface.ALLSTRING) 
-                            && !AuthUtil.isAdministrator(user, groups))
-            {
-                needToCheckAccessModule = true;
-                topAccessSubTreeFromDB = getTopAccessSubTreeFromDB();
-                additionalAccessSubTreeListFromDB =
-                                         getAdditionalAccessSubTreeListFromDB();
-                referencedAccessSubTreeListFromDB =
-                                         getReferencedAccessSubTreeListFromDB();
-            }
-
             //Here is for  data object checking.
-            if (action != null && action.equals("UPDATE"))
-            {
+            if (action != null && action.equals("UPDATE")) {
+            	
+    			// we need to check if user can update access subtree			
+    			int latestRevision = DBUtil.getLatestRevisionInDocumentTable(docid);
+    			String previousDocid = 
+    				docid + PropertyService.getProperty("document.accNumSeparator") + latestRevision;
+    			
+    			PermissionController control = new PermissionController(previousDocid);
+            	
+            	 // If the action is update and user doesn't have "ALL" permission
+                // we need to check if user update access subtree
+            	if ( !control.hasPermission(user, groups, AccessControlInterface.ALLSTRING) 
+                        && !AuthUtil.isAdministrator(user, groups)) {
+                		
+                    needToCheckAccessModule = true;
+                    topAccessSubTreeFromDB = getTopAccessSubTreeFromDB();
+                    additionalAccessSubTreeListFromDB =
+                                             getAdditionalAccessSubTreeListFromDB();
+                    referencedAccessSubTreeListFromDB =
+                                             getReferencedAccessSubTreeListFromDB();
+            	}
+            	
               //info about inline data object which user doesn't have read
               //permission the info come from xml_access table
               previousUnreadableInlineDataObjectHash = PermissionController.
-                            getUnReadableInlineDataIdList(docid, user,
-                                                          groups, true);
+                            getUnReadableInlineDataIdList(previousDocid, user, groups);
 
               //info about data object which user doesn't have write permission
               // the info come from xml_accesss table
               previousUnwritableInlineDataObjectHash = PermissionController.
-                            getUnWritableInlineDataIdList(docid, user,
+                            getUnWritableInlineDataIdList(previousDocid, user,
                                                           groups, true);
 
             }
@@ -2034,9 +2034,22 @@
        String permOrder = newAccess.getPermissionOrder();
        Vector accessRule = newAccess.getAccessRules();
        String subtree     = null;
+       
        // document itself
-       deletePermissionsInAccessTableForDoc(docid);
-       writeGivenAccessRuleIntoDB(permOrder, accessRule, docid, subtree);
+       // use GUID
+       String guid = null;
+		try {
+			guid = IdentifierManager.getInstance().getGUID(docid, Integer.valueOf(revision));
+		} catch (NumberFormatException e) {
+			throw new SAXException(e.getMessage(), e);
+		} catch (McdbDocNotFoundException e) {
+			// register the default mapping now
+			guid = docid + "." + revision;
+			IdentifierManager.getInstance().createMapping(guid, guid);
+		}
+       deletePermissionsInAccessTableForDoc(guid);
+       writeGivenAccessRuleIntoDB(permOrder, accessRule, guid, subtree);
+       
        // for online data, it includes with id and without id.
        // 1. for the data with subtree id, we should ignore the ones already in
        // the hash - onlineURLIdHasAddionalAccess.
@@ -2091,12 +2104,22 @@
                                   " write to xml_access table");
         throw new SAXException("The access object is null");
       }
-       // get rid of rev from dataId
-       //dataId = MetacatUtil.getDocIdFromString(dataId);
-       //String permOrder = accessSection.getPermissionOrder();
+      
+      // geet the guid, not the docid alone
+      String guid = null;
+		try {
+			guid = IdentifierManager.getInstance().getGUID(docid, Integer.valueOf(revision));
+		} catch (NumberFormatException e) {
+			throw new SAXException(e.getMessage(), e);
+		} catch (McdbDocNotFoundException e) {
+			// register the default mapping now
+			guid = docid + "." + revision;
+			IdentifierManager.getInstance().createMapping(guid, guid);
+		}
+      
        String sql = null;
        PreparedStatement pstmt = null;
-       sql = "INSERT INTO xml_access (docid, principal_name, permission, "
+       sql = "INSERT INTO xml_access (guid, principal_name, permission, "
                + "perm_type, perm_order, accessfileid, subtreeid) VALUES "
                + " (?, ?, ?, ?, ?, ?, ?)";
 
@@ -2108,9 +2131,9 @@
            connection.increaseUsageCount(1);
            // Bind the values to the query
            pstmt.setString(1, dataId);
-           logMetacat.info("Docid in accesstable: " + docid);
-           pstmt.setString(6, docid);
-           logMetacat.info("Accessfileid in accesstable: " + docid);
+           logMetacat.info("guid in accesstable: " + dataId);
+           pstmt.setString(6, guid);
+           logMetacat.info("Accessfileid in accesstable: " + guid);
            pstmt.setString(5, permOrder);
            logMetacat.info("PermOder in accesstable: " + permOrder);
            pstmt.setString(7, subTreeId);
@@ -2165,16 +2188,16 @@
     }//writeGivenAccessRuleIntoDB
 
 
-    /* Delete from db all permission for resources related to @docid if any. */
-    private void deletePermissionsInAccessTableForDoc(String docid)
+    /* Delete from db all permission for resources related guid, if any. */
+    private void deletePermissionsInAccessTableForDoc(String guid)
             throws SAXException
     {
         PreparedStatement pstmt = null;
         try {
-        	String sql = "DELETE FROM xml_access WHERE docid = ?";
-            // delete all acl records for resources related to @aclid if any
+        	String sql = "DELETE FROM xml_access WHERE guid = ? ";
+            // delete all acl records for resources related to guid if any
             pstmt = connection.prepareStatement(sql);
-            pstmt.setString(1, docid);
+            pstmt.setString(1, guid);
             // Increase DBConnection usage count
             connection.increaseUsageCount(1);
             pstmt.execute();
@@ -2198,11 +2221,12 @@
        {
     	   String sql = 
     		   "DELETE FROM xml_access " +
-    		   "WHERE accessfileid = ? " +
+    		   "WHERE accessfileid IN (SELECT guid from identifier where docid = ? and rev = ?) " +
                "AND subtreeid = ?";
            pstmt = connection.prepareStatement(sql);
            pstmt.setString(1, docid);
-           pstmt.setString(2, subtreeid);
+           pstmt.setInt(2, Integer.valueOf(revision));
+           pstmt.setString(3, subtreeid);
            // Increase DBConnection usage count
            connection.increaseUsageCount(1);
            pstmt.execute();
@@ -2232,9 +2256,11 @@
        {
     	   String sql = 
     		   "DELETE FROM xml_access " +
-    		   "WHERE accessfileid = ? AND subtreeid IS NOT NULL";
+    		   "WHERE accessfileid IN (SELECT guid from identifier where docid = ? and rev = ?) " +
+    		   "AND subtreeid IS NOT NULL";
            pstmt = connection.prepareStatement(sql);
            pstmt.setString(1, docid);
+           pstmt.setInt(2, Integer.valueOf(revision));
            // Increase DBConnection usage count
            connection.increaseUsageCount(1);
            pstmt.execute();
@@ -2653,11 +2679,11 @@
 
     /*
      * This method will handle data file in online url. If the data file is in
-     * ecogrid protocol, then the datafile identifier(without rev) be returned.
+     * ecogrid protocol, then the datafile identifier (guid) be returned.
      * otherwise, null will be returned.
      * If the data file doesn't exsit in xml_documents or
      * xml_revision table, or the user has all permission to the data file if
-     * the docid already existed, the data file id (without rev)will be returned
+     * the docid already existed, the data file id (guid) will be returned
      * NEED to do:
      * We should also need to implement http and ftp. Those
      * external files should be download and assign a data file id to it.
@@ -2666,6 +2692,8 @@
     {
       logMetacat.warn("The url is "+ url);
       String docid = null;
+      String guid = null;
+
       // if the url is not a ecogrid protocol, null will be getten
       String accessionNumber =
     	  DocumentUtil.getAccessionNumberFromEcogridIdentifier(url);
@@ -2674,6 +2702,14 @@
         // handle ecogrid protocol
         // get rid of revision number to get the docid.
         docid = DocumentUtil.getDocIdFromAccessionNumber(accessionNumber);
+        // use the guid instead
+        int rev = DocumentUtil.getRevisionFromAccessionNumber(accessionNumber);
+		try {
+			guid = IdentifierManager.getInstance().getGUID(docid, rev);
+		} catch (McdbDocNotFoundException e1) {
+			guid = docid + "." + rev;
+			IdentifierManager.getInstance().createMapping(guid, guid);
+		}
         onlineDataFileIdInRelationVector.add(docid);
         try
         {
@@ -2680,7 +2716,7 @@
 
           if (!AccessionNumber.accNumberUsed(docid))
           {
-            return docid;
+            return guid;
           }
           PermissionController controller = new
               PermissionController(accessionNumber);
@@ -2687,12 +2723,12 @@
           if (controller.hasPermission(
               user, groups, AccessControlInterface.ALLSTRING))
           {
-            return docid;
+            return guid;
           }
           else
           {
             throw new SAXException("User: " + user + " does not have permission to update " +
-                  "access rules for data file "+ docid);
+                  "access rules for data file "+ guid);
           }
         }//try
         catch(Exception e)
@@ -2703,7 +2739,7 @@
           throw new SAXException(e.getMessage());
         }
       }
-      return docid;
+      return guid;
     }
 
     private void compareElementNameSpaceAttributes(Stack unchangableNodeStack,
Index: src/edu/ucsb/nceas/metacat/Eml210SAXHandler.java
===================================================================
--- src/edu/ucsb/nceas/metacat/Eml210SAXHandler.java	(revision 6743)
+++ src/edu/ucsb/nceas/metacat/Eml210SAXHandler.java	(revision 6744)
@@ -195,15 +195,20 @@
 				updateDate);
 		// Get the unchangeable subtrees (user doesn't have write permission)
 		try {
-			PermissionController control = new PermissionController(docid
-					+ PropertyService.getProperty("document.accNumSeparator") + revision);
 
-			// If the action is update and user doesn't have "ALL" permission
-			// we need to check if user can update access subtree			
-			if (!control.hasPermission(user, groups, AccessControlInterface.ALLSTRING)
-					&& action != null && action.equals("UPDATE")) {
-				needToCheckAccessModule = true;
-				unChangeableAccessSubTreeVector = getAccessSubTreeListFromDB();
+			if (action.equals("UPDATE")) {
+				// If the action is update and user doesn't have "ALL" permission
+				// we need to check if user can update access subtree			
+				int latestRevision = DBUtil.getLatestRevisionInDocumentTable(docid);
+				String previousDocid = 
+					docid + PropertyService.getProperty("document.accNumSeparator") + latestRevision;
+				
+				PermissionController control = new PermissionController(previousDocid );
+				if (!control.hasPermission(user, groups, AccessControlInterface.ALLSTRING)
+						&& action != null) {
+					needToCheckAccessModule = true;
+					unChangeableAccessSubTreeVector = getAccessSubTreeListFromDB();
+				}
 			}
 
 		} catch (Exception e) {
@@ -1188,7 +1193,7 @@
 	/* The method to write all access rule into db */
 	private void writeAccessRuleToDB() throws SAXException {
 		// Delete old permssion
-		deletePermissionsInAccessTable(docid);
+		deletePermissionsInAccessTable();
 		// write top leve access rule
 		writeTopLevelAccessRuleToDB();
 		// write additional access rule
@@ -1376,8 +1381,12 @@
 
 				if (distributionType == DistributionSection.DATA_DISTRIBUTION) {
 					try {
-						PermissionController controller = new PermissionController(
-								distributionSection.getDataFileName(), false);
+						// check for the previous version for permissions
+						int latestRevision = DBUtil.getLatestRevisionInDocumentTable(distributionSection.getDataFileName());
+						String previousDocid = 
+							distributionSection.getDataFileName() + PropertyService.getProperty("document.accNumSeparator") + latestRevision;
+						PermissionController controller = new PermissionController(previousDocid);
+						
 						if (AccessionNumber.accNumberUsed(docid)
 								&& !controller.hasPermission(user, groups, "WRITE")) {
 							throw new SAXException(UPDATEACCESSERROR);
@@ -1393,8 +1402,12 @@
 					}
 				} else if (distributionType == DistributionSection.INLINE_DATA_DISTRIBUTION && action == "UPDATE") {
 					try {
-						PermissionController controller = new PermissionController(
-								docid, false);
+						
+						// check for the previous version for permissions
+						int latestRevision = DBUtil.getLatestRevisionInDocumentTable(docid);
+						String previousDocid = 
+							docid + PropertyService.getProperty("document.accNumSeparator") + latestRevision;
+						PermissionController controller = new PermissionController(previousDocid);
 
 						if (!controller.hasPermission(user, groups, "WRITE")) {
 							throw new SAXException(UPDATEACCESSERROR);
@@ -1426,15 +1439,26 @@
 			throw new SAXException("The access object is null");
 		}
 
+		String guid = null;
+		try {
+			guid = IdentifierManager.getInstance().getGUID(docid, Integer.valueOf(revision));
+		} catch (NumberFormatException e) {
+			throw new SAXException(e.getMessage(), e);
+		} catch (McdbDocNotFoundException e) {
+			// register the default mapping now
+			guid = docid + "." + revision;
+			IdentifierManager.getInstance().createMapping(guid, guid);
+		}
+		
 		String permOrder = accessSection.getPermissionOrder();
 		String sql = null;
 		PreparedStatement pstmt = null;
 		if (topLevel) {
-			sql = "INSERT INTO xml_access (docid, principal_name, permission, "
+			sql = "INSERT INTO xml_access (guid, principal_name, permission, "
 					+ "perm_type, perm_order, accessfileid) VALUES "
 					+ " (?, ?, ?, ?, ?, ?)";
 		} else {
-			sql = "INSERT INTO xml_access (docid,principal_name, "
+			sql = "INSERT INTO xml_access (guid,principal_name, "
 					+ "permission, perm_type, perm_order, accessfileid, subtreeid"
 					+ ") VALUES" + " (?, ?, ?, ?, ?, ?, ?)";
 		}
@@ -1444,16 +1468,17 @@
 			// Increase DBConnection usage count
 			connection.increaseUsageCount(1);
 			// Bind the values to the query
-			pstmt.setString(6, docid);
-			logMetacat.debug("Accessfileid in accesstable: " + docid);
+			pstmt.setString(6, guid);
+			logMetacat.debug("Accessfileid in accesstable: " + guid);
 			pstmt.setString(5, permOrder);
 			logMetacat.debug("PermOder in accesstable: " + permOrder);
 			// if it is not top level, set subsection id
 			if (topLevel) {
-				pstmt.setString(1, docid);
-				logMetacat.debug("Docid in accesstable: " + docid);
+				pstmt.setString(1, guid);
+				logMetacat.debug("Guid in accesstable: " + guid);
 			}
 			if (!topLevel) {
+				// TODO: look up guid?
 				pstmt.setString(1, accessSection.getDataFileName());
 				logMetacat.debug("Docid in accesstable: " + inlineDataFileName);
 
@@ -1503,79 +1528,18 @@
 
 	}// writeGivenAccessRuleIntoDB
 
-	/* Write a gaven access rule into db */
-	private void writeAccessRuleForRelatedDataFileIntoDB(AccessSection accessSection,
-			String dataId) throws SAXException {
-		if (accessSection == null) {
-			throw new SAXException("The access object is null");
-		}
-		// get rid of rev from dataId
-		// dataId = MetacatUtil.getDocIdFromString(dataId);
-		String permOrder = accessSection.getPermissionOrder();
-		String sql = null;
-		PreparedStatement pstmt = null;
-		sql = "INSERT INTO xml_access (docid, principal_name, permission, "
-				+ "perm_type, perm_order, accessfileid) VALUES " + " (?, ?, ?, ?, ?, ?)";
+	
 
-		try {
-
-			pstmt = connection.prepareStatement(sql);
-			// Increase DBConnection usage count
-			connection.increaseUsageCount(1);
-			// Bind the values to the query
-			pstmt.setString(1, dataId);
-			logMetacat.debug("Docid in accesstable: " + docid);
-			pstmt.setString(6, docid);
-			logMetacat.debug("Accessfileid in accesstable: " + docid);
-			pstmt.setString(5, permOrder);
-			logMetacat.debug("PermOder in accesstable: " + permOrder);
-			// if it is not top level, set subsection id
-
-			Vector<AccessRule> accessRules = accessSection.getAccessRules();
-			// go through every rule
-			for (int i = 0; i < accessRules.size(); i++) {
-				AccessRule rule = accessRules.elementAt(i);
-				String permType = rule.getPermissionType();
-				int permission = rule.getPermission();
-				pstmt.setInt(3, permission);
-				logMetacat.debug("permission in accesstable: " + permission);
-				pstmt.setString(4, permType);
-				logMetacat.debug("Permtype in accesstable: " + permType);
-				// go through every principle in rule
-				Vector<String> nameVector = rule.getPrincipal();
-				for (int j = 0; j < nameVector.size(); j++) {
-					String prName = nameVector.elementAt(j);
-					pstmt.setString(2, prName);
-					logMetacat.debug("Principal in accesstable: " + prName);
-					logMetacat.debug("running sql: " + pstmt.toString());
-					pstmt.execute();
-				}// for
-			}// for
-			pstmt.close();
-		}// try
-		catch (SQLException e) {
-			throw new SAXException("EMLSAXHandler.writeAccessRuletoDB(): "
-					+ e.getMessage());
-		}// catch
-		finally {
-			try {
-				pstmt.close();
-			} catch (SQLException ee) {
-				throw new SAXException("EMLSAXHandler.writeAccessRuletoDB(): "
-						+ ee.getMessage());
-			}
-		}// finally
-
-	}// writeAccessRuleForRalatedDataFileIntoDB
-
-	/* Delete from db all permission for resources related to @aclid if any. */
-	private void deletePermissionsInAccessTable(String aclid) throws SAXException {
+	/* Delete from db all permission for resources related to the document, if any */
+	private void deletePermissionsInAccessTable() throws SAXException {
 		PreparedStatement pstmt = null;
 		try {
-			String sql = "DELETE FROM xml_access WHERE accessfileid = ?";
+			String sql = "DELETE FROM xml_access " +
+					"WHERE accessfileid IN (SELECT guid from identifier where docid = ? and rev = ?)";
 			// delete all acl records for resources related to @aclid if any
 			pstmt = connection.prepareStatement(sql);
-			pstmt.setString(1, aclid);
+			pstmt.setString(1, docid);
+			pstmt.setInt(2, Integer.valueOf(revision));
 			// Increase DBConnection usage count
 			connection.increaseUsageCount(1);
 			logMetacat.debug("running sql: " + sql);
@@ -1829,10 +1793,18 @@
 			// handle ecogrid protocol
 			// get rid of revision number to get the docid.
 			String docid = DocumentUtil.getDocIdFromAccessionNumber(accessionNumber);
+			int rev = DocumentUtil.getRevisionFromAccessionNumber(accessionNumber);
+			String guid = null;
+			try {
+				guid = IdentifierManager.getInstance().getGUID(docid, rev);
+			} catch (McdbDocNotFoundException e1) {
+				guid = docid + "." + rev;
+				IdentifierManager.getInstance().createMapping(guid, guid);
+			}
 
 			currentDistributionSection
 					.setDistributionType(DistributionSection.DATA_DISTRIBUTION);
-			currentDistributionSection.setDataFileName(docid);
+			currentDistributionSection.setDataFileName(guid);
 
 			// distributionOnlineFileName = docid;
 			onlineDataFileIdInRelationVector.add(docid);
Index: src/edu/ucsb/nceas/metacat/IdentifierManager.java
===================================================================
--- src/edu/ucsb/nceas/metacat/IdentifierManager.java	(revision 6743)
+++ src/edu/ucsb/nceas/metacat/IdentifierManager.java	(revision 6744)
@@ -1221,6 +1221,14 @@
      */
     private void insertAccessPolicy(String guid, AccessPolicy accessPolicy) throws McdbDocNotFoundException, AccessException {
     	
+    	// check for the existing permOrder so that we remain compatible with it (DataONE does not care)
+        XMLAccessAccess accessController  = new XMLAccessAccess();
+		String existingPermOrder = AccessControlInterface.ALLOWFIRST;
+        Vector<XMLAccessDAO> existingAccess = accessController.getXMLAccessForDoc(guid);
+        if (existingAccess != null && existingAccess.size() > 0) {
+        	existingPermOrder = existingAccess.get(0).getPermOrder();
+        }
+        
     	List<XMLAccessDAO> accessDAOs = new ArrayList<XMLAccessDAO>();
         for (AccessRule accessRule: accessPolicy.getAllowList()) {
         	List<Subject> subjects = accessRule.getSubjectList();
@@ -1230,20 +1238,24 @@
         		accessDAO.setPrincipalName(subject.getValue());
     			accessDAO.setGuid(guid);
     			accessDAO.setPermType(AccessControlInterface.ALLOW);
-    			accessDAO.setPermOrder(AccessControlInterface.ALLOWFIRST);
-    			for (Permission permission: permissions) {
-    				Long metacatPermission = new Long(convertPermission(permission));
-        			accessDAO.addPermission(metacatPermission);
+				accessDAO.setPermOrder(existingPermOrder);
+    			if (permissions != null) {
+	    			for (Permission permission: permissions) {
+	    				Long metacatPermission = new Long(convertPermission(permission));
+	        			accessDAO.addPermission(metacatPermission);
+	    			}
     			}
     			accessDAOs.add(accessDAO);
         	}
         }
         
-        // use GUID to update
-        XMLAccessAccess accessController  = new XMLAccessAccess(true);
-        accessController.replaceAccess(guid, accessDAOs);
         
+        // remove all existing allow records
+        accessController.deleteXMLAccessForDoc(guid, AccessControlInterface.ALLOW);
+        // add the ones we can for this guid
+        accessController.insertAccess(guid, accessDAOs);
         
+        
     }
     
     /**
@@ -1257,47 +1269,24 @@
         AccessPolicy accessPolicy = new AccessPolicy();
 
     	// use GUID to look up the access
-        XMLAccessAccess accessController  = new XMLAccessAccess(true);
+        XMLAccessAccess accessController  = new XMLAccessAccess();
         List<XMLAccessDAO> accessDAOs = accessController.getXMLAccessForDoc(guid);
         
         for (XMLAccessDAO accessDAO: accessDAOs) {
-        	AccessRule accessRule = new AccessRule();    	
-        	List <Permission> permissions = convertPermission(accessDAO.getPermission().intValue());
-        	accessRule.setPermissionList(permissions);
-        	Subject subject = new Subject();
-        	subject.setValue(accessDAO.getPrincipalName());
-        	accessRule.addSubject(subject);
-            accessPolicy.addAllow(accessRule);
+        	// only add allow rule
+        	if (accessDAO.getPermType().equals(AccessControlInterface.ALLOW)) {
+	        	AccessRule accessRule = new AccessRule();    	
+	        	List <Permission> permissions = convertPermission(accessDAO.getPermission().intValue());
+	        	accessRule.setPermissionList(permissions);
+	        	Subject subject = new Subject();
+	        	subject.setValue(accessDAO.getPrincipalName());
+	        	accessRule.addSubject(subject);
+	            accessPolicy.addAllow(accessRule);
+        	}
         }
         return accessPolicy;
     }
     
-    /**
-     * Lookup access policy from Metacat
-     * @param guid
-     * @return
-     * @throws McdbDocNotFoundException
-     * @throws AccessException
-     */
-    public AccessPolicy getAccessPolicyByLocalId(String docid) throws McdbDocNotFoundException, AccessException {
-        AccessPolicy accessPolicy = new AccessPolicy();
-
-    	// use GUID to look up the access
-        XMLAccessAccess accessController  = new XMLAccessAccess(false);
-        List<XMLAccessDAO> accessDAOs = accessController.getXMLAccessForDoc(docid);
-        
-        for (XMLAccessDAO accessDAO: accessDAOs) {
-        	AccessRule accessRule = new AccessRule();    	
-        	List <Permission> permissions = convertPermission(accessDAO.getPermission().intValue());
-        	accessRule.setPermissionList(permissions);
-        	Subject subject = new Subject();
-        	subject.setValue(accessDAO.getPrincipalName());
-        	accessRule.addSubject(subject);
-            accessPolicy.addAllow(accessRule);
-        }
-        return accessPolicy;
-    }
-    
     public int convertPermission(Permission permission) {
     	if (permission.equals(Permission.READ)) {
     		return AccessControlInterface.READ;
@@ -1312,26 +1301,26 @@
     }
     
     public List<Permission> convertPermission(int permission) {
+    	
     	List<Permission> permissions = new ArrayList<Permission>();
-    	if (permission == AccessControlInterface.READ) {
+    	if (permission == AccessControlInterface.ALL) {
     		permissions.add(Permission.READ);
-    		return permissions;
-    	}
-    	if (permission == AccessControlInterface.WRITE) {
     		permissions.add(Permission.WRITE);
+    		permissions.add(Permission.CHANGE_PERMISSION);
     		return permissions;
     	}
-    	if (permission == AccessControlInterface.CHMOD) {
+    	
+    	if ((permission & AccessControlInterface.CHMOD) == AccessControlInterface.CHMOD) {
     		permissions.add(Permission.CHANGE_PERMISSION);
-    		return permissions;
     	}
-    	if (permission == AccessControlInterface.ALL) {
+    	if ((permission & AccessControlInterface.READ) == AccessControlInterface.READ) {
     		permissions.add(Permission.READ);
+    	}
+    	if ((permission & AccessControlInterface.WRITE) == AccessControlInterface.WRITE) {
     		permissions.add(Permission.WRITE);
-    		permissions.add(Permission.CHANGE_PERMISSION);
-    		return permissions;
     	}
-		return null;
+    	
+		return permissions;
     }
     
     /**
@@ -1698,7 +1687,7 @@
             rows = stmt.executeUpdate();
             stmt.close();
             
-            // TODO: remove the xml_access?
+            // TODO: remove the access?
             // Metacat keeps "deleted" documents so we should not remove access rules.
             
         } catch (Exception e) {
Index: src/edu/ucsb/nceas/metacat/DocInfoHandler.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DocInfoHandler.java	(revision 6743)
+++ src/edu/ucsb/nceas/metacat/DocInfoHandler.java	(revision 6744)
@@ -50,7 +50,7 @@
 	private String _accessPermOrder;
 	private String _accessFileId;
 	private String _subTreeId;
-	private String _docId;
+	private String _guid;
 	private boolean _inPrincipal = false;
 	private boolean _inPermission = false;
 	private boolean _inAllow = false;
@@ -64,8 +64,8 @@
 	public DocInfoHandler() {
 	}
 
-	public DocInfoHandler(String docId) {
-		_docId = docId;
+	public DocInfoHandler(String guid) {
+		_guid = guid;
 	}
   
    /**
@@ -95,11 +95,10 @@
 			// new principal means new DAO for storing it
 			_inPrincipal = true;
 			_currentAccessDAO = new XMLAccessDAO();
-			_currentAccessDAO.setDocId(_docId);
+			_currentAccessDAO.setGuid(_guid);
 			_currentAccessDAO.setPermOrder(_accessPermOrder);
 			_currentAccessDAO.setAccessFileId(_accessFileId);
 			_currentAccessDAO.setSubTreeId(_subTreeId);
-			_currentAccessDAO.setDocId(_docId);
 			if (_inAllow) {
 				_currentAccessDAO.setPermType(AccessControlInterface.ALLOW);
 			}
